# -*- coding: utf-8 -*-

"""
restapisdk

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from restapisdk.models.group_permission import GroupPermission


class DependentPermission(object):

    """Implementation of the 'DependentPermission' model.

    TODO: type model description here.

    Attributes:
        id (string): GUID of the object
        name (string): Name of the object
        mtype (string): Indicates the type of the object
        permission (string): Indicates the permission which user or user group
            has on the object
        shared_permission (string): Indicates the permission which user or
            user group has on the object through sharing of the object with
            this user or user group
        group_permission (list of GroupPermission): An array of object with
            details of permission on the user groups to which the user or user
            group belongs

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "id": 'id',
        "name": 'name',
        "mtype": 'type',
        "permission": 'permission',
        "shared_permission": 'sharedPermission',
        "group_permission": 'groupPermission'
    }

    def __init__(self,
                 id=None,
                 name=None,
                 mtype=None,
                 permission=None,
                 shared_permission=None,
                 group_permission=None):
        """Constructor for the DependentPermission class"""

        # Initialize members of the class
        self.id = id
        self.name = name
        self.mtype = mtype
        self.permission = permission
        self.shared_permission = shared_permission
        self.group_permission = group_permission

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        id = dictionary.get('id')
        name = dictionary.get('name')
        mtype = dictionary.get('type')
        permission = dictionary.get('permission')
        shared_permission = dictionary.get('sharedPermission')
        group_permission = None
        if dictionary.get('groupPermission') is not None:
            group_permission = [GroupPermission.from_dictionary(x) for x in dictionary.get('groupPermission')]
        # Return an object of this model
        return cls(id,
                   name,
                   mtype,
                   permission,
                   shared_permission,
                   group_permission)
